/*
 * fft-matcher-nlogm.c
 *
 *  Created on: 6 Jul 2010
 *      Author: ben
 */
#include <fftw3.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "match-with-dont-cares.h"

/**
 * Usage:
 * matcher text pattern n m [wild card char]
 */

int main (int argc, char *argv[]){

	char *text, *pattern, wildCardChar;
	int n,m,start;

	/*Start by doing a few sanity checks on the input */
	if(argc < 5){
		printUsageAndExit();
	}

	text = argv[1];
	pattern = argv[2];

	sscanf(argv[3],"%d",&n);
	sscanf(argv[4],"%d",&m);

	if(m > n || m < 0 || n < 0){
		printUsageAndExit();
	}

	if(argc > 5){
		sscanf(argv[5],"%c",&wildCardChar);
	}else{
		wildCardChar = '?';
	}


	//Iteratively divide the text into overlapping chunks of size 2m, and search these.
	char *textPortion = (char *) malloc(sizeof(char) * 2 * m);

	while(start < n-m){
		strncpy(textPortion,text,m*2);
		matchWithFFT(textPortion,pattern,wildCardChar,m*2,m,start);
		text += m;
		start +=m;
	}

	return 0;
}
