/*
 * fft-matcher.c
 *
 *  Created on: 5 Jul 2010
 *      Author: Ben Smithers
 */
#include <fftw3.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "match-with-dont-cares.h"

/**
 * Usage:
 * matcher text pattern n m [wild card char]
 */

int main (int argc, char *argv[]){

	char *text, *pattern, wildCardChar;
	int n,m;

	/*Start by doing a few sanity checks on the input */
	if(argc < 5){
		printUsageAndExit();
	}

	text = argv[1];
	pattern = argv[2];

	sscanf(argv[3],"%d",&n);
	sscanf(argv[4],"%d",&m);

	if(m > n || m < 0 || n < 0){
		printUsageAndExit();
	}

	if(argc > 5){
		sscanf(argv[5],"%c",&wildCardChar);
	}else{
		wildCardChar = '?';
	}

	matchWithFFT(text,pattern,wildCardChar,n,m,0);

 	return 0;
}
