/*
 * naive-matcher.c
 *
 *  Created on: 5 Jul 2010
 *      Author: Ben Smithers
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "match-with-dont-cares.h"

/**
 * Usage:
 * matcher text pattern n m [wild card char]
 */

void printUsageAndExit(void);

int main (int argc, char *argv[]){

	char *text, *pattern, wildCardChar;
	int n,m,i,j,matchFound;

	/*Start by doing a few sanity checks on the input */
	if(argc < 5){
		printUsageAndExit();
	}

	text = argv[1];
	pattern = argv[2];

	sscanf(argv[3],"%d",&n);
	sscanf(argv[4],"%d",&m);

	if(m > n || m < 0 || n < 0){
		printUsageAndExit();
	}

	if(argc > 5){
		sscanf(argv[5],"%c",&wildCardChar);
	}else{
		wildCardChar = '?';
	}

	//loop though each possible index and check each value

	for(i=0;i<=n-m;i++){
		matchFound = 1;
		j = 0;
		for(j=0;j<m;j++){
			if(text[i+j] != pattern[j] && text[i+j] != '?' && pattern[j] != '?'){
				matchFound = 0;
				break;
			}
		}
		if(matchFound){
			printf("Match at index %d\n",i);
		}
	}
}
